// #autoload
// #name = DioScavenge
// #version = 3.95
// #date = 3/18/2002 11:49PM
// #status = release
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://dioscripts.tribes-universe.com
// #description = Weapon scavenging script. Hold down the scavenge key, and you will drop all weapons, and grenades that don't match your current loadout, as well as optional pack dropping.
// #category = DioScripts
// #include = support/loadout.cs
// #config = DioScavengeConfig

if(!isObject(DioScavenge))
{
	new ScriptObject(DioScavenge)
	{
		class = DioScavenge;
	};
}

package DioScavenge {
	
function DioScavenge (%val){
	if(%val){
		
		$favstr = $pref::Favorite[$pref::FavCurrentSelect];
		
		$favstr = strreplace($favstr, " ", "");
		$favstr = strreplace($favstr, "Spinfusor", "Disc");
		$favstr = strreplace($favstr, "LaserRifle", "SniperRifle");
		$favstr = strreplace($favstr, "ELFProjector", "ELFGun");
		$favstr = strreplace($favstr, "Shocklance", "ShockLance");
		$favstr = $favstr @ " TargetingLaser";
		
		DioScavengeCheckWeapon(1);
		if (DioScavenge.schedule != 0) 
			cancel(DioScavenge.schedule);
		DioScavenge.schedule = schedule(500, 0, DioScavengeCheckWeapon);
		
		if($pref::DioScavenge::ScavGrens){
			if(strstr( $favstr, "Flare" ) >0){
				DioScavenge::GrenadeDrop(flaregrenade);
			}
			else if(strstr( $favstr, "Whiteout" ) >0){
				DioScavenge::GrenadeDrop(flashgrenade);
			}
			else if(strstr( $favstr, "Concussion" ) >0){
				DioScavenge::GrenadeDrop(concussiongrenade);
			}
			else if(strstr( $favstr, "Camera" ) >0){
				DioScavenge::GrenadeDrop(cameragrenade);
			}
			else{
				DioScavenge::GrenadeDrop(reggrenade);
			}
		}
		
		if($pref::DioScavenge::ScavPack){
			if(strstr($favstr,loadout.getPack()) < 1 ){
				throwPack(1);
			}
		}
		
		if($pref::DioScavenge::ScavAmmo){
			DioScavenge::DropAmmo();
		}
		
		if (DioScavenge.soundschedule != 0) 
			cancel(DioScavenge.soundschedule);
		DioScavenge.soundschedule = schedule(1000, 0, DioScavengeSound);
	}
}

function DioScavengeSound(%this){
	if(loadout.getGrenadeAmmo() > 0){
		alxPlay( BountyBellSound, 0, 0, 0);
	}
	else{
		alxPlay( InputDeniedSound, 0, 0, 0);
	}
}

function DioScavengeCheckWeapon(%this){
	for(%i=0; %i < 11; %i++){
		if(loadout.isLoadoutWeapon($WeaponNames[%i])){
			if(strstr( $favstr, $WeaponNames[%i] ) < 0){
				clientCmdSetWeaponsHudItem(%i,0,0);
				throw($WeaponNames[%i]);
			}
		}
	}
}			

function DioScavenge::GrenadeDrop(%grenades){
	%glist = "reggrenade reggrenade flashgrenade flashgrenade flaregrenade flaregrenade concussiongrenade concussiongrenade cameragrenade cameragrenade ";
	%glist = strreplace(%glist, %grenades @" ", "");
	%glist = strreplace(%glist, "reggrenade", "grenade");
	for(%i=0; %i < 8; %i++){
		%drop = getword(%glist, %i);
		throw(%drop);
	}
}

function DioScavenge::DropAmmo(){
	if(strstr( $favstr, "Plasma" ) < 0){
		DioScavenge::ThrowAmmo(PlasmaAmmo);
	}
	if(strstr( $favstr, "Chaingun" ) < 0){
		DioScavenge::ThrowAmmo(ChaingunAmmo);
	}
	if(strstr( $favstr, "Disc" ) < 0){
		DioScavenge::ThrowAmmo(DiscAmmo);
	}
	if(strstr( $favstr, "GrenadeLauncher" ) < 0){
		DioScavenge::ThrowAmmo(GrenadeLauncherAmmo);
	}
	if(strstr( $favstr, "Mortar" ) < 0){
		DioScavenge::ThrowAmmo(MortarAmmo);
	}
	if(strstr( $favstr, "Missile" ) < 0){
		DioScavenge::ThrowAmmo(MissileLauncherAmmo);
	}
}

function DioScavenge::ThrowAmmo(%ammo){
	for(%i=1; %i < 5; %i++){
		Throw(%ammo);
	}
}

function DioScavengeAuto(%val){
	DioScavenge(1);
}

function DioScavengeSetup (%this){
	
	new GuiControl(DioScavengeConfig) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellPaneCtrl() {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "251 167";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "DioScavenge";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";

			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 29";
				extent = "211 120";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};

			new ShellToggleButton(DioScavGrensButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "45 33";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioScavenge::ScavGrens";
				helpTag = "0";
				text = "SCAVENGE GRENADES";
				maxLength = "255";
			};
			new ShellToggleButton(DioScavPackButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 60";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioScavenge::ScavPack";
				helpTag = "0";
				text = "SCAVENGE PACKS";
				maxLength = "255";
			};
			new ShellToggleButton(DioScavAmmoButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 86";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioScavenge::ScavAmmo";
				helpTag = "0";
				text = "SCAVENGE AMMO";
				maxLength = "255";
			};
			new ShellToggleButton(DioScavAutoButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 112";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioScavenge::Auto";
				helpTag = "0";
				text = "AUTO SCAVENGE";
				maxLength = "255";
			};

		};
	};
	
	if($pref::DioScavenge::Enabled $= ""){
		$pref::DioScavenge::Enabled = true;
		$pref::DioScavenge::ScavGrens = true;
		$pref::DioScavenge::ScavAmmo = false;
		$pref::DioScavenge::ScavPack = false;
		$pref::DioScavenge::Auto = false;
	}
	
	DioScavGrensButton.setValue($pref::DioScavenge::ScavGrens);
	DioScavAmmoButton.setValue($pref::DioScavenge::ScavAmmo);
	DioScavPackButton.setValue($pref::DioScavenge::ScavPack);
	DioScavAutoButton.setValue($pref::DioScavenge::Auto);
	
	if($pref::DioScavenge::Auto){
		callback.add(onItemPickup,DioScavengeAuto);
		$DioScavenge::AutoCallbacks = true;
	}
}

function DioScavengeAutoToggle(%val){
	if(%val){
		if($pref::DioScavenge::Auto){
			if($DioScavenge::AutoCallbacks){
				callback.delete(onItemPickup,DioScavengeAuto);
				$DioScavenge::AutoCallbacks = false;
			}
			$pref::DioScavenge::Auto = false;
			%message = "\c5DioScavenge:\c0 Manual~wvoice/training/any/any.tip.scavenge02.wav";
		}	
		else{
			if(!$DioScavenge::AutoCallbacks){
				callback.add(onItemPickup,DioScavengeAuto);
				$DioScavenge::AutoCallbacks = true;				
			}
			$pref::DioScavenge::Auto = true;
			%message = "\c5DioScavenge:\c0 Automatic~wvoice/training/any/any.tip.scavenge01.wav";
		}
		defaultmessagecallback('', %message);
	}
}

function DioScavengeConfig::OnSleep(%this){
	echo("Options Done");
		if(!$DioScavenge::AutoCallbacks){
			if($pref::DioScavenge::Auto){
				callback.add(onItemPickup,DioScavengeAuto);
				$DioScavenge::AutoCallbacks = true;
			}
		}
		else{
			if(!$pref::DioScavenge::Auto){
				callback.delete(onItemPickup,DioScavengeAuto);
				$pref::DioScavenge::Auto = false;
			}
		}
}

function OptionsDlg::onWake( %this ) {//Classic key binding
	if(!$DioScavengeBind) {
		$RemapName[$RemapCount]="DioScavenge - Scavenge";
		$RemapCmd[$RemapCount]="DioScavenge";
		$RemapCount++;
		
		$RemapName[$RemapCount]="DioScavenge - AutoToggle";
		$RemapCmd[$RemapCount]="DioScavengeAutoToggle";
		$RemapCount++;
		$DioScavengeBind = true;
	}
	parent::onWake( %this );
}
};
activatePackage(DioScavenge);

if($AutoloadExecuted)
	DioScavengeSetup();

///////////////////////////////////////////////////////
//
//	Support.vl2? New Callback I needed
//
///////////////////////////////////////////////////////
function handleItemPickup (%msgType, %msgString)
{
	callback.trigger(onItemPickup, %msgString);
}
addMessageCallback( 'MsgItemPickup', handleItemPickup );
